'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDeleteHandler = exports.createLoadHandler = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _difference = require('lodash/difference');

var _difference2 = _interopRequireDefault(_difference);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _values = require('lodash/values');

var _values2 = _interopRequireDefault(_values);

var _uniq = require('lodash/uniq');

var _uniq2 = _interopRequireDefault(_uniq);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _set = require('lodash/set');

var _set2 = _interopRequireDefault(_set);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultLoadOptions = {
  mapToKey: false,
  withLoading: true,
  singular: false,
  withReplace: false,
  addToState: {}
};

var createLoadHandler = exports.createLoadHandler = function createLoadHandler(resourceType, options) {
  return function (state, _ref) {
    var payload = _ref.payload;

    var _defaultLoadOptions$o = _extends({}, defaultLoadOptions, options),
        mapToKey = _defaultLoadOptions$o.mapToKey,
        withLoading = _defaultLoadOptions$o.withLoading,
        singular = _defaultLoadOptions$o.singular,
        withReplace = _defaultLoadOptions$o.withReplace,
        addToState = _defaultLoadOptions$o.addToState;

    var payloadResource = (0, _get2.default)(payload, 'data.' + resourceType, false);

    var mappedResourceType = mapToKey || resourceType;

    // $FlowFixMe
    var nextState = _defineProperty({}, mappedResourceType, state[mappedResourceType]);

    if (singular) {
      (0, _set2.default)(nextState, mappedResourceType, (0, _get2.default)((0, _values2.default)(payloadResource), '0.id'));
    } else {
      (0, _set2.default)(nextState, mappedResourceType, withReplace ? (0, _map2.default)(payloadResource, 'id') : (0, _uniq2.default)([].concat(_toConsumableArray((0, _get2.default)(state, mappedResourceType, [])), _toConsumableArray((0, _map2.default)(payloadResource, 'id')))));
    }

    if (withLoading) {
      var addKey = mapToKey ? (0, _helpers.capitalizeFirstLetter)(mapToKey) : '';
      nextState['isLoaded' + addKey] = true;
      nextState['isLoading' + addKey] = false;
    }

    return state.merge(_extends({}, nextState, addToState));
  };
};

// TODO: add coverage for lines 86, 87, 89
var createDeleteHandler = exports.createDeleteHandler = function createDeleteHandler(stateKey) {
  return function (state, _ref2) {
    var payload = _ref2.payload;

    var deletedIds = (0, _get2.default)(payload, 'deletedIds') || [(0, _get2.default)(payload, 'deletedId')];

    var stateValue = state[stateKey];

    return state.merge(_defineProperty({}, stateKey, (0, _isArray2.default)(stateValue) ? (0, _difference2.default)(stateValue, deletedIds) : (0, _helpers.nullifyIfIncludes)(deletedIds, stateValue)));
  };
};